//
// named.conf
//
// Provided by Red Hat bind package to configure the ISC BIND named(8) DNS
// server as a caching only nameserver (as a localhost DNS resolver only).
//
// See /usr/share/doc/bind*/sample/ for example named configuration files.
//
// See the BIND Administrator's Reference Manual (ARM) for details about the
// configuration located in /usr/share/doc/bind-{version}/Bv9ARM.html

acl "trusted" {
{% for host in groups['all'] %}
   	{{ hostvars[host]['ansible_eth1']['ipv4']['address'] }};
{% endfor %}
};

options {
	listen-on port 53 { 127.0.0.1; {{ inventory_hostname }}; };
	#listen-on-v6 port 53 { ::1; };
	directory 	"/var/named";
	dump-file 	"/var/named/data/cache_dump.db";
	statistics-file "/var/named/data/named_stats.txt";
	memstatistics-file "/var/named/data/named_mem_stats.txt";
	recursing-file  "/var/named/data/named.recursing";
	secroots-file   "/var/named/data/named.secroots";
	allow-query     { localhost; 192.168.33.10; trusted; };

	/* 
	 - If you are building an AUTHORITATIVE DNS server, do NOT enable recursion.
	 - If you are building a RECURSIVE (caching) DNS server, you need to enable 
	   recursion. 
	 - If your recursive DNS server has a public IP address, you MUST enable access 
	   control to limit queries to your legitimate users. Failing to do so will
	   cause your server to become part of large scale DNS amplification 
	   attacks. Implementing BCP38 within your network would greatly
	   reduce such attack surface 
	*/
	recursion yes;

	dnssec-enable yes;
	dnssec-validation yes;

	/* Path to ISC DLV key */
	bindkeys-file "/etc/named.root.key";

	managed-keys-directory "/var/named/dynamic";

	pid-file "/run/named/named.pid";
	session-keyfile "/run/named/session.key";
};

logging {
        channel default_debug {
                file "data/named.run";
                severity dynamic;
        };
};

zone "." IN {
	type hint;
	file "named.ca";
};

include "/etc/named.rfc1912.zones";
include "/etc/named.root.key";

zone "com" {
    type slave;
    file "/etc/named/zones/db.com"; # zone file path
	masters { {{ groups['mainHAProxy'][0] }}; };
};

zone "{{ hostvars[inventory_hostname]['ansible_eth1']['ipv4']['network'][:-2].split(".")[::-1]|join('.') }}.in-addr.arpa" {
    type slave;
    file "/etc/named/zones/db.{{ hostvars[inventory_hostname]['ansible_eth1']['ipv4']['network'][:-2].split(".")[::-1]|join('.') }}";  # 192.168.33.0/24 subnet
	masters { {{ groups['mainHAProxy'][0] }}; };
};